﻿// PlaneProjectionExperimenter by Charles Petzold, January 2010
using System;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Controls.Primitives;
using System.Windows.Input;

namespace PlaneProjectionExperimenter
{
    public partial class MainPage : UserControl
    {
        bool initialized;

        public MainPage()
        {
            InitializeComponent();
            LayoutUpdated += OnMainPageLayoutUpdated;
        }

        void OnMainPageLayoutUpdated(object sender, EventArgs e)
        {
            if (!initialized)
            {
                thumbTranslate.X = projectedElement.ActualWidth / 2;
                thumbTranslate.Y = projectedElement.ActualHeight / 2;
                initialized = true;
            }
        }

        void OnThumbDragDelta(object sender, DragDeltaEventArgs args)
        {
            thumbTranslate.X += args.HorizontalChange;
            thumbTranslate.Y += args.VerticalChange;

            planeProjection.CenterOfRotationX = thumbTranslate.X / projectedElement.ActualWidth;
            planeProjection.CenterOfRotationY = thumbTranslate.Y / projectedElement.ActualHeight;

            xCenterText.Text = planeProjection.CenterOfRotationX.ToString("F3");
            yCenterText.Text = planeProjection.CenterOfRotationY.ToString("F3");
        }

        protected override void OnMouseWheel(MouseWheelEventArgs args)
        {
            planeProjection.CenterOfRotationZ += args.Delta / 12.0;
            thumbScale.ScaleX = thumbScale.ScaleY =
                Math.Pow(2, planeProjection.CenterOfRotationZ / 100);

            zCenterText.Text = planeProjection.CenterOfRotationZ.ToString("F1");

            base.OnMouseWheel(args);
        }
    }
}

