﻿// ThreePanelCarousel by Charles Petzold, January 2010
using System;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Media;

namespace ThreePanelCarousel
{
    public partial class MainPage : UserControl
    {
        Button clickedButton;
        bool noMoreTriggers;

        public MainPage()
        {
            InitializeComponent();
            storyboard.Completed += OnStoryboardCompleted1;
        }

        private void OnButtonClick(object sender, RoutedEventArgs args)
        {
            if (noMoreTriggers)
                return;

            clickedButton = sender as Button;
            noMoreTriggers = true;

            if (IsAncestorOf(segment1, clickedButton))
            {
                Canvas.SetZIndex(segment2, 1);
                Canvas.SetZIndex(segment3, 0);
            }
            else if (IsAncestorOf(segment2, clickedButton))
            {
                Canvas.SetZIndex(segment1, 0);
                Canvas.SetZIndex(segment3, 1);
            }
            else if (IsAncestorOf(segment3, clickedButton))
            {
                Canvas.SetZIndex(segment1, 1);
                Canvas.SetZIndex(segment2, 0);
            }

            storyboard.Completed += OnStoryboardCompleted1;
            storyboard.Begin();
        }

        void OnStoryboardCompleted1(object sender, EventArgs args)
        {
            storyboard.Completed -= OnStoryboardCompleted1;

            if (IsAncestorOf(segment1, clickedButton))
            {
                Canvas.SetZIndex(segment1, 1);
                Canvas.SetZIndex(segment2, 2);
            }
            else if (IsAncestorOf(segment2, clickedButton))
            {
                Canvas.SetZIndex(segment2, 1);
                Canvas.SetZIndex(segment3, 2);
            }
            else if (IsAncestorOf(segment3, clickedButton))
            {
                Canvas.SetZIndex(segment1, 2);
                Canvas.SetZIndex(segment3, 1);
            }

            storyboard.Completed += OnStoryboardCompleted2;
            storyboard.Begin();
        }

        void OnStoryboardCompleted2(object sender, EventArgs args)
        {
            storyboard.Completed -= OnStoryboardCompleted2;
            noMoreTriggers = false;
        }

        static bool IsAncestorOf(DependencyObject ancestor, DependencyObject child)
        {
            if (ancestor == child)
                return true;

            DependencyObject parent = VisualTreeHelper.GetParent(child);

            if (parent == null)
                return false;

            return IsAncestorOf(ancestor, parent);
        }
    }
}
